/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <gtk/gtk.h>
#include <stdio.h>
#include "tms.h"

#ifndef GTK
#include <curses.h>
#endif

#ifdef LINUX
#include <gtk/gtk.h>
#endif

#ifdef CODE_SEGMENT
#pragma segment MAIN_C
#endif

char *entry_text;

#ifndef MAC_68k
int main( int argc, char** argv )
    {
    char my_save_filename[256];
    gtk_init( &argc, &argv );
    entry_text = calloc(ENTRY_TEXT_LENGTH, sizeof(char));
    initial_user_selection = menu_choice(
      "Welcome to the world Espiriticthus. Would you like to:",
      initial_menu_choice, 6);
    if (initial_user_selection == 5)
        exit(0);
    tsrandom();
    if (initial_user_selection == 4)
        {
        g_print(my_save_filename);
        new_tgets("What is the filename?", my_save_filename, SAVE_FILE);
        init_restore(my_save_filename);
        }
    else if ( 1 == argc ) 
        init( );
    else if ( 2 == argc )
        init_restore( argv[1] );
    else
        {
        fprintf( stderr, "Usage: %s [GTK options] [savefile]\n\n", argv[0] ); 
        exit( 1 );
        }
    show_main_window_contents();
#ifdef GTK
    /*
    g_timeout_add(500, tms_idle, NULL);
    */
    gtk_idle_add(tms_idle, NULL);
    gtk_main();
    return 0;
#endif
    }
#else
void main(void)
    {
    game_variables = NULL;
    init();
    for(;;)
        {
        EVENT_CHECK
        if (!(flag_check(game_variables->flags, IN_BETWEEN_GAMES)))
            {
            game_variables->elapsed_units += current_level->timescale;
            if (game_variables->elapsed_units >= DAY)
                {
                ++game_variables->elapsed_days;
                game_variables->elapsed_units -= DAY;
                }
            update_world();
            }
        else
            {
            if (!(flag_check(game_variables->flags, DURING_INIT)))
                {
                end_game();
#ifdef MAC_68k
                window_clear();
#endif
                pmsg("Please select an option under the file menu.");
                }
#ifdef MAC_68k
            event_check();
            Delay(1, 0);
#endif
            }
        }
    }
#endif
